unit UMain;

interface

uses UStruct;

function ProcuraTerminal( numTerminal : PChar) : Integer; stdcall;
function PegaAutorizacao( const solicAutorizacao : PTR_SOLICITA_AUTORIZACAO; var dadosAutorizacao : DADOS_AUTORIZACAO ) : Integer; stdcall;
function CancelaAutorizacao( const dadosAutorizacao : PTR_DADOS_AUTORIZACAO ) : Integer; stdcall;
function SolicitaDadosTerminal( const dadosLojista : PTR_DADOS_LOJISTA; var dadosTerminalPos : TICKET_DADOS_POS ) : Integer; stdcall;
function ConsultaSaldo( dadosLojista : PTR_DADOS_LOJISTA ) : Integer; stdcall;
function DesfazAutorizacao( numTerminal : PChar ) : Integer; stdcall;
function PegaRelatorio( const solicita : PTR_SOLICITA_RELATORIO; var dados : DADOS_RELATORIO ) : Integer; stdcall;
function InicializaBD( usuario : PChar; senha : PChar; strHost : PChar; numMax : Smallint	) : Integer; stdcall;

implementation

uses SysUtils;

var numOperadoras : char = #0;

function ProcuraTerminal( numTerminal : PChar) : Integer; stdcall;
begin
  ProcuraTerminal := ST_OK;
end;

function PegaAutorizacao( const solicAutorizacao : PTR_SOLICITA_AUTORIZACAO; var dadosAutorizacao : DADOS_AUTORIZACAO ) : Integer; stdcall;
var temp : String;
		i : Integer;
begin
	FillChar(dadosAutorizacao, sizeof(dadosAutorizacao), #0);

  move('1526674571', dadosAutorizacao.Nsu, 10);

  FillChar(dadosAutorizacao.DadosOperadora.RazaoSocial, sizeof(dadosAutorizacao.DadosOperadora.RazaoSocial), #0);
  for i := 0 to sizeof(solicAutorizacao.Operadora) - 1 do
    if (solicAutorizacao.Operadora[i] <> ' ') then dadosAutorizacao.DadosOperadora.RazaoSocial[i] := solicAutorizacao.Operadora[i];
  move('02319126000159', dadosAutorizacao.DadosOperadora.Cnpj, TAM_CNPJ - 4);
  FillChar(dadosAutorizacao.DadosOperadora.Ie, sizeof(dadosAutorizacao.DadosOperadora.Ie), ' ');
  move('115192221115', dadosAutorizacao.DadosOperadora.Ie, TAM_IE - 3);
  move('CENTRAL DE ATENDIMENTO', dadosAutorizacao.DadosOperadora.Help1, 22);
  move('*5000 do seu celular', dadosAutorizacao.DadosOperadora.Help2, 20);
  move('Da pra tomar', dadosAutorizacao.DadosOperadora.Help3, 12);
  move('uma Kaiser antes', dadosAutorizacao.DadosOperadora.Help4, 16);

  temp := FormatDateTime('ddmmyyyy', Now);
  for i := 1 to length(temp) do
    dadosAutorizacao.Data[i - 1] := temp[i];

  temp := FormatDateTime('hhnnss', Now);
  for i := 1 to length(temp) do
    dadosAutorizacao.Hora[i - 1] := temp[i];

  dadosAutorizacao.numCargaOper := '215726365688';
  PegaAutorizacao := ST_OK;
end;

function CancelaAutorizacao( const dadosAutorizacao : PTR_DADOS_AUTORIZACAO ) : Integer; stdcall;
begin
	CancelaAutorizacao := ST_OK;
end;

function SolicitaDadosTerminal( const dadosLojista : PTR_DADOS_LOJISTA; var dadosTerminalPos : TICKET_DADOS_POS ) : Integer; stdcall;
var numOper, opcao, k : Integer;
		temp : String;
    asd : Integer;
begin
	Randomize;
	asd := 1 + random(4);
	for numOper := 0 to MAX_OPERADORA - asd do
  	FillChar( dadosTerminalPos.DadosOperadora[numOper].Valor, sizeof(dadosTerminalPos.DadosOperadora[numOper].Valor), '0');

  dadosTerminalPos.TimeOut := #35;
  for numOper := 0 to MAX_OPERADORA - asd do
  begin
    FillChar(dadosTerminalPos.DadosOperadora[numOper].Operadora, sizeof(dadosTerminalPos.DadosOperadora[numOper].Operadora), ' ');
    temp := 'TELET' + IntToStr(numOper) + '    ';
    for opcao := 0 to TAM_NM_OPERADORA - 1 do
      dadosTerminalPos.DadosOperadora[numOper].Operadora[opcao] := temp[opcao + 1];
    FillChar(dadosTerminalPos.DadosOperadora[numOper].Valor, sizeof(dadosTerminalPos.DadosOperadora[numOper].Valor), '0');

    case numOper of
    	0, 3 :
      	for opcao := 1 to 4 do
        begin
          temp := Format('00000%d000%d', [numOper, opcao]);
          for k := 0 to TAM_VL_COMPRA - 1 do
            dadosTerminalPos.DadosOperadora[numOper].Valor[opcao][k] := temp[k + 1];
        end;
      1 :
      	for opcao := 1 to 2 do
        begin
          temp := Format('00000%d000%d', [numOper, opcao]);
          for k := 0 to TAM_VL_COMPRA - 1 do
            dadosTerminalPos.DadosOperadora[numOper].Valor[opcao][k] := temp[k + 1];
        end;
      2 :
      	for opcao := 1 to 3 do
        begin
          temp := Format('00000%d000%d', [numOper, opcao]);
          for k := 0 to TAM_VL_COMPRA - 1 do
            dadosTerminalPos.DadosOperadora[numOper].Valor[opcao][k] := temp[k + 1];
        end;
    end;
    dadosTerminalPos.NumOperadoras := Chr(numOper + 1);
  end;

	NumOperadoras := dadosTerminalPos.NumOperadoras;

  SolicitaDadosTerminal := ST_OK;
end;

function ConsultaSaldo( dadosLojista : PTR_DADOS_LOJISTA ) : Integer; stdcall;
var temp : String;
		i, j : Integer;
begin
	Randomize;
	i := random(10);
  Randomize;
  j := random(10);
  if i > 10 then i := 0;
  if j > 10 then j := 0;

	temp := Format('000%d%d%d%d%d00', [i, j, i * j, i * i, j * j]);
  for i := 0 to sizeof(dadosLojista.Saldo) - 1 do
  	if (temp[i + 1] >= '0') and (temp[i + 1] <= '9') then dadosLojista.Saldo[i] := temp[i + 1];

  ConsultaSaldo := ST_OK;
end;

function DesfazAutorizacao( numTerminal : PChar ) : Integer; stdcall;
begin
	DesfazAutorizacao := ST_OK;
end;

function PegaRelatorio( const solicita : PTR_SOLICITA_RELATORIO; var dados : DADOS_RELATORIO ) : Integer; stdcall;
var numOper, opcao, k : Integer;
		temp : String;
    total : Int64;
    totParcial : Int64;
begin
	dados.NumOperadoras := numOperadoras;
  total := 0;

  for numOper := 0 to MAX_OPERADORA - 1 do
  	FillChar( dados.RelatorioOperadora[numOper].Valor, sizeof(dados.RelatorioOperadora[numOper].Valor), '0');

  if Ord(numOperadoras) > 0 then
  begin
    for numOper := 0 to Ord(numOperadoras) - 1 do
    begin
    	totParcial := 0;
      FillChar(dados.RelatorioOperadora[numOper].Operadora, sizeof(dados.RelatorioOperadora[numOper].Operadora), ' ');
      temp := 'TELET' + IntToStr(numOper) + '    ';
      for opcao := 0 to TAM_NM_OPERADORA - 1 do
        dados.RelatorioOperadora[numOper].Operadora[opcao] := temp[opcao + 1];

      FillChar(dados.RelatorioOperadora[numOper].Valor, sizeof(dados.RelatorioOperadora[numOper].Valor), '0');
			case numOper of
        0, 3 :
        	begin
            for opcao := 1 to 4 do
            begin
              temp := Format('0000%d%d0%d0%d', [numOper+opcao, numOper, 2*numOper, opcao]);
              totParcial := totParcial + StrToInt64(temp);
              for k := 0 to TAM_VL_COMPRA - 1 do
                dados.RelatorioOperadora[numOper].Valor[opcao][k] := temp[k + 1];
            end;
            temp := Format('%0.10d', [totParcial]);
            for k := 0 to TAM_VL_COMPRA - 1 do
              dados.RelatorioOperadora[numOper].Valor[5][k] := temp[k + 1];

            total := total + totParcial;
            temp := Format('%0.10d', [total]);
            for k := 0 to TAM_VL_COMPRA - 1 do
              dados.RelatorioOperadora[numOper].Valor[6][k] := temp[k + 1];

          end;
        1 :
        	begin
            for opcao := 1 to 2 do
            begin
              temp := Format('0000%d%d0%d0%d', [numOper+opcao, numOper, 2*numOper, opcao]);
              totParcial := totParcial + StrToInt64(temp);
              for k := 0 to TAM_VL_COMPRA - 1 do
                dados.RelatorioOperadora[numOper].Valor[opcao][k] := temp[k + 1];
            end;
            temp := Format('%0.10d', [totParcial]);
            for k := 0 to TAM_VL_COMPRA - 1 do
              dados.RelatorioOperadora[numOper].Valor[5][k] := temp[k + 1];

            total := total + totParcial;
            temp := Format('%0.10d', [total]);
            for k := 0 to TAM_VL_COMPRA - 1 do
              dados.RelatorioOperadora[numOper].Valor[6][k] := temp[k + 1];
          end;
        2 :
        	begin
            for opcao := 1 to 3 do
            begin
              temp := Format('0000%d%d0%d0%d', [numOper+opcao, numOper, 2*numOper, opcao]);
              totParcial := totParcial + StrToInt64(temp);
              for k := 0 to TAM_VL_COMPRA - 1 do
                dados.RelatorioOperadora[numOper].Valor[opcao][k] := temp[k + 1];
            end;
						temp := Format('%0.10d', [totParcial]);
            for k := 0 to TAM_VL_COMPRA - 1 do
              dados.RelatorioOperadora[numOper].Valor[5][k] := temp[k + 1];

            total := total + totParcial;
            temp := Format('%0.10d', [total]);
            for k := 0 to TAM_VL_COMPRA - 1 do
              dados.RelatorioOperadora[numOper].Valor[6][k] := temp[k + 1];
          end;
      end;
    end;
    PegaRelatorio := ST_OK;
  end
  else
		PegaRelatorio := 1;
end;

function InicializaBD( usuario : PChar; senha : PChar; strHost : PChar; numMax : Smallint	) : Integer; stdcall;
//function ConectaBD( usuario : PChar; senha : PChar; strHost : PChar ) : Integer; stdcall;
begin
  //ConectaBD := ST_OK;
  InicializaBD := ST_OK;
end;

end.
