unit UStruct;

interface

const
  ST_OK		    = 0;

  TAM_ID_TERMINAL   = 8;
  TAM_TRILHA2       = 40;
  TAM_SENHA         = 18;
  TAM_CNPJ          = 18;
  TAM_IE            = 17;
  TAM_TELEFONE	    = 10;
  TAM_DIGITO        = 2;
  TAM_VL_COMPRA     = 10;
  TAM_NM_OPERADORA  = 10;
  TAM_NSU_AUTORIZ   = 10;
  TAM_DATA          = 8;
  TAM_HORA          = 6;
  TAM_COD_CARGA     = 12;
  TAM_SALDO         = 12;

  MAX_OPERADORA     = 4;

type
  PTR_SALDO_LOJISTA = ^SALDO_LOJISTA;
  SALDO_LOJISTA = packed record
    saldo : array[0..TAM_SALDO - 1] of char;
  end;

  PTR_DADOS_LOJISTA = ^DADOS_LOJISTA;
  DADOS_LOJISTA = packed record
    Terminal    : array[0..TAM_ID_TERMINAL - 1] of char;
    Trilha2     : array[0..TAM_TRILHA2 - 1] of char;
    Senha       : array[0..TAM_SENHA - 1] of char;
    Saldo       : array[0..TAM_SALDO - 1] of char;
  end;

  PTR_DADOS_TKT_OPERADORA = ^DADOS_TKT_OPERADORA;
  DADOS_TKT_OPERADORA = packed record
    RazaoSocial : array[0..24 - 1] of char;
    Cnpj        : array[0..TAM_CNPJ - 1] of char;
    Ie          : array[0..TAM_IE - 1] of char;
    Help1       : array[0..24 - 1] of char;
    Help2       : array[0..24 - 1] of char;
    Help3       : array[0..24 - 1] of char;
    Help4       : array[0..24 - 1] of char;
  end;

  PTR_SOLICITA_AUTORIZACAO = ^SOLICITA_AUTORIZACAO;
  SOLICITA_AUTORIZACAO = packed record
    Lojista     : DADOS_LOJISTA;
    Telefone    : array[0..TAM_TELEFONE - 1] of char;
    CheckDigit  : array[0..TAM_DIGITO - 1] of char;
    ValorCompra : array[0..TAM_VL_COMPRA - 1] of char;
    Operadora   : array[0..TAM_NM_OPERADORA - 1] of char;
  end;

  PTR_DADOS_OPERADORA = ^DADOS_OPERADORA;
  DADOS_OPERADORA = packed record
    Operadora   : array[0..TAM_NM_OPERADORA - 1] of char;
    Valor       : array[1..6, 0..TAM_VL_COMPRA - 1] of char;
  end;

  PTR_TICKET_DADOS_POS = ^TICKET_DADOS_POS;
  TICKET_DADOS_POS = packed record
    TimeOut         : char;
    NumOperadoras   : char;
    DadosOperadora  : array[0..MAX_OPERADORA - 1] of DADOS_OPERADORA;
  end;

  PTR_DADOS_AUTORIZACAO = ^DADOS_AUTORIZACAO;

  DADOS_AUTORIZACAO = packed record
    DadosOperadora	: DADOS_TKT_OPERADORA;
    flag            : char;
    Nsu	            : array[0..TAM_NSU_AUTORIZ - 1] of char;
    Data            : array[0..TAM_DATA - 1] of char;
    Hora            : array[0..TAM_HORA - 1] of char;
    numCargaOper    : array[0..TAM_COD_CARGA - 1] of char;
  end;

  RELATORIO_OPERADORA = DADOS_OPERADORA;

  PTR_SOLICITA_RELATORIO = ^SOLICITA_RELATORIO;
  SOLICITA_RELATORIO = packed record
    Lojista     : DADOS_LOJISTA;
    Operadora   : array[0..TAM_NM_OPERADORA-1] of char; //
    Tipo    : char;                                    // 0-Saldo, 1-Simples, ...
    DataI   : array[0..TAM_DATA-1] of char;           //  ddmmaaaa  --->  se for por periodo
    DataF   : array[0..TAM_DATA-1] of char;          //   ddmmaaaa
  end;

  PTR_DADOS_RELATORIO = ^DADOS_RELATORIO;
  DADOS_RELATORIO = packed record
    NumOperadoras       : char;
    RelatorioOperadora  : array[0..MAX_OPERADORA-1] of RELATORIO_OPERADORA;
  end;

implementation

end.
